# Files to run client using docker

## Update compose file

Edit docker-compose.yml and change the following under **commands** for service **boringproxy**
- bp.example.com: your admin domain
- your-user-token: token generated by your server
- your-email-address: the email address to register with Let's Encrypt

### certmagic

The certmagic volume is used to store certificates. This directory must also be passed to the container with the -cert-dir command.

==If you make changes to this, make sure that the data in certmagic is persistent, otherwise new certificates will be generated every time the container is started. This can result in triggering the [rate limits for Let's Encrypt](https://letsencrypt.org/docs/rate-limits/)==

### /etc/ssl/certs
Alpine doesn't include ca-certificates in the docker base image. You can add your OS ca-certificates to the docker container by linking your local certs directory to the image
- /etc/ssl/certs/:/etc/ssl/certs/:ro

## Build image from source and run server in docker
You can build the image from source. This requires that you clone the GitHub repo and start docker using the compose command below:

```bash
docker-compose -f docker-compose.yml -f source.yml up -d
```

## Download prebuild image and run server in docker
If you don't want to build the image, a prebuild image can be downloaded from GitHub. Start docker using the compose commands below to download the image and start the container.

```bash
docker-compose -f docker-compose.yml -f prebuild.yml up -d
```